﻿//getData
sumflag=0;
function getifmdocByid(ids, docs)
{
	if(arguments.length < 2) docs=document
	var xx=docs.getElementById(ids);
	var yy=(xx.contentWindow || xx.contentDocument);
	if (yy.document)yy=yy.document;
	return yy;
}
//EnergySeledBy = parent.engseled
dataSelBy = parent.datselby
dataTabHeader = new Array()
seriesColorsAry = [ "#0087dc", "#EEB50A" , "#41C400"]
units=1000;  //kWh
//units=1;  //Wh
dataUnits = ["V","A","W","%","Hz","C","F",""]
ohlcChart = ["Lo / Hi"]
var dataTabAry = []
var dataGroup = []
var dataItem = []
var dataItemName = []
var dataItemIx = []
var dataItemNum = []
var dataVal = []
var ifrm = parent.$('#DATAIDFRAME').contents()
function getDataVal(texts,types)
{	//types == 0 , return val
	//types == 1 , return unit
	//types == null, return array : [val, unit]
	var ary = [texts,texts]
	$.each(dataUnits, function(index,value){
		if (texts.indexOf(value) > -1)
		{
			texts = texts.replace(value,"")
			ary = [texts,value]
			return false
		}
	})
	if (arguments.length > 1) return (types == 0)?ary[0]:ary[1]
	else return ary
}
function analysisTabData()
{
	ifrm.find('table tr').each(function(index,value)
	{
		var xindex = index
		var xthis = this
		dataTabAry[xindex] = []
		$(xthis).find('td').each(function(index,value){
			if (xindex == 0){	//Title
				if ($(this).is(".title[colspan!=1]"))
				{
					for (var i=0;i<$(this).attr("colspan");i++)
					{
						if (i==0)dataTabAry[xindex].push($(this).text())
						else dataTabAry[xindex].push("")
					}
				}
				else dataTabAry[xindex].push($(this).text())
			}
			else if (xindex == 1){	//Subtitle
				if (index == 0){dataTabAry[xindex].push('');dataTabAry[xindex].push('')}
				dataTabAry[xindex].push($(this).text())
			}
			else { // Datas
				dataTabAry[xindex].push($(this).text())
			}
		})
	})
	return dataTabAry
}
function rgb2hex(rgb) {
	rgb = rgb.match(/^rgb\((\d+),\s*(\d+),\s*(\d+)\)$/i);
	function hex(x) {return ("0" + parseInt(x).toString(16)).slice(-2);}
	return "#" + hex(rgb[1]) + hex(rgb[2]) + hex(rgb[3]);
}
function addzero(val){return (parseInt(val) >= 10) ? val : ("0" + String(val))}
//Chart
chartObj = null;
dateary = []
//ccc = 0
function legendClick() {
	$("td.jqplot-table-legend").live("click",(function() {
		//ccc++;
		//$("#ary",parent.document).html("ccc="+ccc)
		//if( ccc % 2 != 1)return
		//$("#ary",parent.document).text($("div.jqplot-table-legend-swatch").html())
		colorsel=(ns)?"background-color":"border-color";
		indexs = $("td.jqplot-table-legend").index($(this));
		indexs2 = Math.floor(indexs/2)
		seriescolor = chartObj.seriesColors[indexs2].toUpperCase();
		objs = $("div.jqplot-table-legend-swatch").eq(indexs2)
		if(ns)thiscolor = rgb2hex(objs.css(colorsel)).toUpperCase()
		else  thiscolor = objs.css(colorsel).toUpperCase()
		colors = (thiscolor==seriescolor?"#cccccc":seriescolor)
		objs.css("border-color",colors);
		if(ns)objs.css(colorsel,colors);
		if(colors == "#cccccc")chartObj.moveSeriesToFront((indexs2==0)?1:0)
		else chartObj.moveSeriesToFront(indexs2)
	}))
}
function setTickUnit()
{
	$.each(unitArys,function(index,value){
		if (value !="" )
		{
			ix = (index == 0)?"":(index+1)
			str = "<div style='position:absolute;top:324px;letter-spacing:-1px;font-size:12px;font-family:arial;white-space:nowrap;' class='jqplot-y"+ix+"axis-tick'>("+value+")</div>"
			if ($('.jqplot-y'+ix+'axis').html().indexOf("("+value+")") == -1)
				$('.jqplot-y'+ix+'axis').append(str)
		}
	})
	$(".xticks").hide().css({"letter-spacing":"-1px","padding-left":"4px","padding-right":"4px"})
	$(".xticks:odd").hide().css({"color":"#666","padding-top":"12px"})
	$(".xticks").show()
}
function drawPlot(dtType,types,lineary)
{
	$('#chart0').empty()
	if (chartObj != null) chartObj.destroy();
	chartObj = $.jqplot('chart0', lineary, createPlot(dtType,types))
	$.jqplot.preDrawHooks.push(function(){
		if (chartObj.plugins.cursor.zoom)
		{
			setTimeout("setTickUnit();",4)
		}
	});
	chartObj.replot();
}
function altary2(arys)
{
    strs = "<Br>length ="+arys.length+"<Br>";
    for (i = 0; i < arys.length ; i++)
    {
        strs += "("+addzero(i)+") - "+arys[i]+"<Br>"
    }
    return strs;
}
unitstr = []
aryData = [[],[],[]]
function createPlot(dtTypes,types)
{// types = [Line1Type, Line2Type.....]
	font_size = '12px';
	font_family = 'Arial';
	angles = '0'
	labelPos = 'middle'
	xmin = $("#from0",parent.document).val();
	xmax = $("#to0",parent.document).val();
	ynumTicks = 10;
	xticks = []
	font_sizes = font_size
	if(dtTypes == 0) //Day
	{
		xnumTicks = 25;
		fmstr = '%H'
		xmax = "24:00"
		xmin = "00:00"
		tickInv = '1 hour'
	}
	else if (dtTypes == 1) //Month
	{
		xnumTicks = 30;
		fmstr = '%d';
		tickInv = '1 day'
	}
	else  if(dtTypes == 2) //Year
	{
		xnumTicks = 12;
		fmstr = '%m';
		tickInv = '1 month'
	}
	else if (dtTypes == 3) //user defined
	{
		xnumTicks = 11;
		fmstr = "<div align=center class='xticks'>%m/%d/%Y<Br/>%T</div>"
		xmax += " 24:00:00"
		xmin += " 00:00:00"
		tickInv = ''
	}
	xNoDataAry = []
	yNoDataAry = []
	for(var i=0;i<11;i++){yNoDataAry.push(i*10)}
	xformat = {labelPosition:labelPos,fontSize:font_size,fontFamily:font_family,angle:angles,formatString:fmstr}
	tickopt = {formatString:'%d',fontSize:font_size,fontFamily:font_family}
	seriesAry = [{},{yaxis:'y2axis'},{yaxis:'y3axis'}]
	$.each(types,function(index,value){
		if (value == 1)
		{
			if(index == 0)
				 obj = {renderer:$.jqplot.OHLCRenderer, rendererOptions:{candleStick:true,fillUpBody:true}}
			else obj = {renderer:$.jqplot.OHLCRenderer, rendererOptions:{candleStick:true,fillUpBody:true},yaxis:'y'+(index+1)+'axis'}
			seriesAry[index] = obj
		}
	})
	$.jqplot.config.enablePlugins = true;
	valunit = ""
	var optionsObj = {
		seriesColors:seriesColorsAry,
		defaultAxisStart: 0,
		seriesDefaults:{
			showMarker:false,
			lineWidth:1,
			shadow: false,
			markerOptions: {
				size:2
			}
		},
		series:seriesAry,
		axesDefaults:{useSeriesColor: true},
		axes:{
			xaxis:{
				renderer:$.jqplot.DateAxisRenderer,
				numberTicks:xnumTicks,
				tickOptions:{
					fontSize:font_sizes,
					fontFamily:font_family,
					angle:angles,
					formatString:fmstr
				},
				tickInterval:tickInv,
				ticks:xticks,
				max:xmax,
				min:xmin
			},
			yaxis:	{tickOptions:tickopt,numberTicks:ynumTicks,pad:1.2,min:0},
			y2axis:	{tickOptions:tickopt,numberTicks:ynumTicks,pad:1.5,min:0},
			y3axis:	{tickOptions:tickopt,numberTicks:ynumTicks,pad:1.8,min:0}
		},
		highlighter: {
			showMarker:false,
			lineWidthAdjust:2.5,
			tooltipLocation:'nw',
			tooltipOffset:4,
			show:true,
			tooltipAxes: 'xy',
			yvalues:5,
			tooltipContentEditor:editit
		},
		cursor: {
			style: 'default',
			show: true,
			zoom:true,
			showTooltip:false,
			tooltipFormatString:'%0.1f',
			dbclickReset:true
		},
		legend:
		{
			renderer: $.jqplot.EnhancedLegendRenderer,
			show:true,
			location:'s',
			placement:'outsideGrid',
			shrinkGrid:false,
			rendererOptions:{numberRows:1},
			labels:legendArys,
			xoffset: 110
		},
		noDataIndicator:{
			 show:true, //Loading Data...
			indicator:"<div id=nodata style='margin:0 auto;font-size:20px;color:#0E70CB;border:1px #0E70CB solid;background:#FFF;width:200px;height:28px'>"+$(".chartStr0",parent.document).html()+"</div>",
			legend:{show:false,labels:['','']},
			series:[{},{yaxis:'y2axis'}],
			axes:{
				xaxis:{
					renderer:$.jqplot.DateAxisRenderer,
					numberTicks:xnumTicks,
					tickOptions:{
						//labelPosition:labelPos,
						fontSize:font_sizes,
						fontFamily:font_family,
						//angle:angles,
						formatString:fmstr
					},
					tickInterval:tickInv,
					ticks:xticks,
					max:xmax,
					min:xmin
				},
				yaxis :{tickOptions:tickopt,max:100,min:0,tickInterval:10,numberTicks:11,ticks:yNoDataAry},
				y2axis:{tickOptions:tickopt,max:100,min:0,tickInterval:10,numberTicks:11,ticks:yNoDataAry}
			}
		}
	}
	return optionsObj;
}
lastTop = 200;
function editit(str, si, pi, plot) {
	var bkc = ["#DFEFFD","#FEF5DA","#FFF"]
	var color = chartObj.seriesColors[si]
	var unitstrs = unitArys[si]
	var bkcolor = bkc[si]
	var strary = lineDataAry[si][pi]
	maxv = Math.max(strary[1],Math.max(strary[2],strary[3]))
	minv = Math.min(strary[1],Math.min(strary[2],strary[3]))
	dType = $('#datetype',parent.document).val()

	if (legendArys[si].indexOf("Lo / Hi") != -1)
		 str = legendArys[si]+"<br>"+strary[0]+" <br> "+minv+" "+unitstrs +" / "+maxv+" "+unitstrs
	else str = legendArys[si]+"<br>"+strary[0]+" <br> "+strary[1]+" "+unitstrs
	setTimeout("funcs()",50)
	funcs = function(){
		otop = $('.jqplot-highlighter-tooltip').offset().top
		oleft = $('.jqplot-highlighter-tooltip').offset().left
		if (otop < 20) $('.jqplot-highlighter-tooltip').hide().css({"top":"20px"}).show()
		if (oleft < 30) $('.jqplot-highlighter-tooltip').hide().css({"left":"30px"}).show()
		if (otop > 300)	$('.jqplot-highlighter-tooltip').hide().css({"top":"200px"}).show()
		else lastTop = otop
	}
	return '<div id="hl" style="text-align:center;padding:1px 4px;border:2px '+color+' solid;background-color:#FFF;font-size:12px;color:#333;font-family:Arial;">'+str+'</div>'
}